<?php
if ( ! function_exists( 'supermarket_shopping_setup' ) ) :
function supermarket_shopping_setup() {

// Root path/URI.
define( 'SUPERMARKET_SHOPPING_PARENT_DIR', get_template_directory() );
define( 'SUPERMARKET_SHOPPING_PARENT_URI', get_template_directory_uri() );

// Root path/URI.
define( 'SUPERMARKET_SHOPPING_PARENT_INC_DIR', SUPERMARKET_SHOPPING_PARENT_DIR . '/inc');
define( 'SUPERMARKET_SHOPPING_PARENT_INC_URI', SUPERMARKET_SHOPPING_PARENT_URI . '/inc');

	// Add default posts and comments RSS feed links to head.
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'wc-product-gallery-zoom' );
	add_theme_support( 'wc-product-gallery-slider' );

	/*
	 * Let WordPress manage the document title.
	 */
	add_theme_support( 'title-tag' );

	add_theme_support( 'responsive-embeds' );
	
	/*
	 * Enable support for Post Thumbnails on posts and pages.
	 */
	add_theme_support( 'post-thumbnails' );
	
	//Add selective refresh for sidebar widget
	add_theme_support( 'customize-selective-refresh-widgets' );
	
	/*
	 * Make theme available for translation.
	 */
	load_theme_textdomain( 'supermarket-shopping', get_stylesheet_directory() . '/languages' );
		
	// This theme uses wp_nav_menu() in one location.
	register_nav_menus( array(
		'primary'  => esc_html__( 'Primary Menu', 'supermarket-shopping' ),
	) );

	/*
	 * Switch default core markup for search form, comment form, and comments
	 * to output valid HTML5.
	 */
	add_theme_support( 'html5', array(
		'search-form',
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );
		
	add_theme_support('custom-logo');

	/*
	 * WooCommerce Plugin Support
	 */
	add_theme_support( 'woocommerce' );
	
	// Gutenberg wide images.
	add_theme_support( 'align-wide' );
	
	
	//Set up the WordPress core custom background feature.
	add_theme_support( 'custom-background', apply_filters( 'supermarket_shopping_custom_background_args', array(
		'default-color' => 'ffffff',
		'default-image' => '',
	) ) );


	/*
	 * This theme styles the visual editor to resemble the theme style,
	 * specifically font, colors, icons, and column width.
	 */
	add_editor_style( array( 'assets/css/editor-style.css', supermarket_shopping_google_font_url() ) );

    add_theme_support( 'custom-header', apply_filters( 'supermarket_shopping_custom_header_args', array(
		'default-image'          => get_template_directory_uri() . '/assets/images/custom-header.png',
		'default-text-color'     => 'ffffff',
		'width'                  => 2000, 
		'height'                 => 200,
		'flex-width'    		 => true,
		'flex-height'    		 => true,
        'uploads'            => true,
	)));


    /*
    * Enable support for Post Formats.
    *
    * See: https://codex.wordpress.org/Post_Formats
    */
    add_theme_support( 'post-formats', array('image','video','gallery','audio',) );


    //  --------------------------------------------- ENQUEUE ----------------------------------------------------- //

    /**
     * Implement the Custom Header feature.
     */
    require_once get_template_directory() . '/inc/custom-header.php';

    /**
     * Demo Import
     */
    require get_parent_theme_file_path( '/demo-import/demo-import-settings.php' );

    if ( ! defined( 'SUPERMARKET_SHOPPING_FREE_THEME_URL' ) ) {
        define( 'SUPERMARKET_SHOPPING_FREE_THEME_URL', 'https://www.seothemesexpert.com/products/free-supermarket-wordpress-theme' );
    }
    if ( ! defined( 'SUPERMARKET_SHOPPING_PRO_THEME_URL' ) ) {
        define( 'SUPERMARKET_SHOPPING_PRO_THEME_URL', 'https://www.seothemesexpert.com/products/supermarket-website-template' );
    }
    if ( ! defined( 'SUPERMARKET_SHOPPING_FREE_DOCS_THEME_URL' ) ) {
        define( 'SUPERMARKET_SHOPPING_FREE_DOCS_THEME_URL', 'https://demo.seothemesexpert.com/documentation/supermarket-shopping/' );
    }
    if ( ! defined( 'SUPERMARKET_SHOPPING_DEMO_THEME_URL' ) ) {
        define( 'SUPERMARKET_SHOPPING_DEMO_THEME_URL', 'https://demo.seothemesexpert.com/supermarket-shopping-pro/' );
    }
    if ( ! defined( 'SUPERMARKET_SHOPPING_RATE_THEME_URL' ) ) {
        define( 'SUPERMARKET_SHOPPING_RATE_THEME_URL', 'https://wordpress.org/support/theme/supermarket-shopping/reviews/#new-post' );
    }
    if ( ! defined( 'SUPERMARKET_SHOPPING_SUPPORT_THEME_URL' ) ) {
        define( 'SUPERMARKET_SHOPPING_SUPPORT_THEME_URL', 'https://wordpress.org/support/theme/supermarket-shopping/' );
    }
    if ( ! defined( 'SUPERMARKET_SHOPPING_THEME_BUNDLE_URL' ) ) {
        define( 'SUPERMARKET_SHOPPING_THEME_BUNDLE_URL', 'https://www.seothemesexpert.com/products/wordpress-theme-bundle' );
    }
    if ( ! defined( 'SUPERMARKET_SHOPPING_DEMO_IMPORT_URL' ) ) {
        define( 'SUPERMARKET_SHOPPING_DEMO_IMPORT_URL', esc_url( admin_url( 'themes.php?page=supermarketshopping-wizard' ) ) );
    }

}
endif;
add_action( 'after_setup_theme', 'supermarket_shopping_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $content_width
 */
function supermarket_shopping_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'supermarket_shopping_content_width', 1170 );
}
add_action( 'after_setup_theme', 'supermarket_shopping_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */

function supermarket_shopping_widgets_init() {
	
	register_sidebar( array(
		'name' => __( 'Sidebar Widget Area', 'supermarket-shopping' ),
		'id' => 'supermarket-shopping-sidebar-primary',
		'description' => __( 'The Primary Widget Area', 'supermarket-shopping' ),
		'before_widget' => '<aside id="%1$s" class="widget %2$s wow fadeInUp">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4><div class="title"><span class="shap"></span></div>',
	) );
	
	register_sidebar( array(
		'name' => __( 'Footer Widget Area', 'supermarket-shopping' ),
		'id' => 'supermarket-shopping-footer-widget-area',
		'description' => __( 'The Footer Widget Area', 'supermarket-shopping' ),
		'before_widget' => '<div class="footer-widget col-lg-3 col-sm-6 wow fadeIn" data-wow-delay="0.5s"><aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside></div>',
		'before_title' => '<h5 class="widget-title w-title">',
		'after_title' => '</h5><span class="shap"></span>',
	) );
}
add_action( 'widgets_init', 'supermarket_shopping_widgets_init' );


/**
 * All Styles & Scripts.
 */
require_once get_template_directory() . '/inc/enqueue.php';

/**
 * Nav Walker fo Bootstrap Dropdown Menu.
*/
require_once get_template_directory() . '/inc/class-wp-bootstrap-navwalker.php';

/**
 * Custom template tags for this theme.
 */
require_once get_template_directory() . '/inc/template-tags.php';

/**
 * Customizer additions.
 */
require_once get_template_directory() . '/inc/customizer.php';

/**
 * Custom functions that act independently of the theme templates.
 */
require_once get_template_directory() . '/inc/extras.php';

require_once get_template_directory() . '/inc/fonts.php';

require_once get_template_directory() . '/wptt-webfont-loader.php';


function supermarket_shopping_custom_controls() {
	load_template( trailingslashit( get_template_directory() ) . '/inc/customizer/customizer-custom-controls.php' );
}
add_action( 'customize_register', 'supermarket_shopping_custom_controls' );


add_filter( 'nav_menu_link_attributes', 'supermarket_shopping_dropdown_data_attribute', 20, 3 );
/**
 * Use namespaced data attribute for Bootstrap's dropdown toggles.
 *
 * @param array    $atts HTML attributes applied to the item's `<a>` element.
 * @param WP_Post  $item The current menu item.
 * @param stdClass $args An object of wp_nav_menu() arguments.
 * @return array
 */
function supermarket_shopping_dropdown_data_attribute( $atts, $item, $args ) {
    if ( is_a( $args->walker, 'WP_Bootstrap_Navwalker' ) ) {
        if ( array_key_exists( 'data-toggle', $atts ) ) {
            unset( $atts['data-toggle'] );
            $atts['data-bs-toggle'] = 'dropdown';
        }
    }
    return $atts;
}

function supermarket_shopping_remove_theme_customizer_setting($wp_customize) {
    // Remove the setting
    $wp_customize->remove_setting('display_header_text');
    // Remove the control
    $wp_customize->remove_control('display_header_text');
}
add_action('customize_register', 'supermarket_shopping_remove_theme_customizer_setting', 20); 
// Use a priority greater than the one used for adding the setting


// Set the number of products per row to 3 on the shop page
add_filter('loop_shop_columns', 'supermarket_shopping_custom_shop_loop_columns');

if (!function_exists('supermarket_shopping_custom_shop_loop_columns')) {
    function supermarket_shopping_custom_shop_loop_columns() {
        // Retrieve the number of columns from theme customizer setting (default: 3)
        $supermarket_shopping_columns = get_theme_mod('supermarket_shopping_custom_shop_per_columns', 3);
        return $supermarket_shopping_columns;
    }
}

// Set the number of products per page on the shop page
add_filter('loop_shop_per_page', 'supermarket_shopping_custom_shop_per_page', 20);

if (!function_exists('supermarket_shopping_custom_shop_per_page')) {
    function supermarket_shopping_custom_shop_per_page($supermarket_shopping_products_per_page) {
        // Retrieve the number of products per page from theme customizer setting (default: 9)
        $supermarket_shopping_products_per_page = get_theme_mod('supermarket_shopping_custom_shop_product_per_page', 9);
        return $supermarket_shopping_products_per_page;
    }
}

/**
 * Generate Google fonts URL.
 */
function supermarket_shopping_google_font_url() {
    $supermarket_shopping_font_family = array(
        'Inter:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900'
    );

    $supermarket_shopping_query_args = array(
        'family' => implode('|', $supermarket_shopping_font_family), // No need for rawurlencode in this case
        'display' => 'swap' // Add display=swap to improve loading performance
    );

    return esc_url(add_query_arg($supermarket_shopping_query_args, 'https://fonts.googleapis.com/css2')); // Use https://fonts.googleapis.com/css2 for variable fonts
}

/**
 * Enqueue theme styles and scripts.
 */

function supermarket_shopping_scripts_styles() {
	$supermarket_shopping_headings_font = esc_html(get_theme_mod('supermarket_shopping_headings_text'));
	$supermarket_shopping_body_font = esc_html(get_theme_mod('supermarket_shopping_body_text'));

	if( $supermarket_shopping_headings_font ) {
		wp_enqueue_style( 'supermarket-shopping-headings-fonts', '//fonts.googleapis.com/css?family='. $supermarket_shopping_headings_font );
	} else {
		// Enqueue Google Fonts
        wp_enqueue_style('supermarket-shopping-google-fonts', supermarket_shopping_google_font_url(), array(), null);
	}
	if( $supermarket_shopping_body_font ) {
		wp_enqueue_style( 'supermarket-shopping-body-fonts', '//fonts.googleapis.com/css?family='. $supermarket_shopping_body_font );
	} else {
		// Enqueue other styles and scripts as needed
        wp_enqueue_style('supermarket-shopping-main-style', get_stylesheet_uri(), array(), '1.0.0');
        // Add more enqueuing here if needed
	}
}
add_action( 'wp_enqueue_scripts', 'supermarket_shopping_scripts_styles' );

function supermarket_shopping_customize_css() {
    $supermarket_shopping_dynamic_color = get_theme_mod( 'supermarket_shopping_dynamic_color_one', '#78B85D' );
    $supermarket_shopping_custom_css = ":root { --color-primary1: {$supermarket_shopping_dynamic_color}; }";
    wp_add_inline_style( 'supermarket-shopping-style', $supermarket_shopping_custom_css );
}
add_action( 'wp_enqueue_scripts', 'supermarket_shopping_customize_css' );

/**
 * Enqueue theme copyright alignment style.
 */
function supermarket_shopping_copyright_alignment_option() {
    // Get the alignment setting from the theme customizer.
    $supermarket_shopping_copyright_alignment = get_theme_mod('supermarket_shopping_copyright_alignment', 'center');

    // Start building the CSS string for the alignment.
    $supermarket_shopping_copyright_alignment_css = '
        .copyright-text, .footer-copyright, .footer-copyright a, p.copyright-text{
            text-align: ' . esc_attr($supermarket_shopping_copyright_alignment) . ';
        }
    ';

    // Add the inline style to the theme's main stylesheet.
    wp_add_inline_style('supermarket-shopping-style', $supermarket_shopping_copyright_alignment_css);
}

add_action('wp_enqueue_scripts', 'supermarket_shopping_copyright_alignment_option');

// Sanitize the input
function supermarket_shopping_sanitize_sidebar_position( $supermarket_shopping_input ) {
    $supermarket_shopping_valid = array( 'right', 'left' );

    if ( in_array( $supermarket_shopping_input, $supermarket_shopping_valid ) ) {
        return $supermarket_shopping_input;
    } else {
        return 'right';
    }
}

// Helper function to get page ID by slug
function get_page_id_by_slug($supermarket_shopping_slug) {
    $supermarket_shopping_page = get_page_by_path($supermarket_shopping_slug); // Get the page by slug
    return $supermarket_shopping_page ? $supermarket_shopping_page->ID : 0;   // Return the page ID or 0 if not found
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );

// Show Admin Notice
function supermarket_shopping_promo_notice() {
    if (get_option('supermarket_shopping_notice_dismissed')) {
        return;
    }

    if (isset($_GET['page']) && in_array($_GET['page'], ['supermarketshopping-wizard', 'greengrocer-wizard'])) {
        return;
    }
    

    $supermarket_shopping_theme = wp_get_theme();
    $supermarket_shopping_theme_title = $supermarket_shopping_theme->get( 'Name' );
    $supermarket_shopping_theme_version = $supermarket_shopping_theme->get( 'Version' );

    ?>
    <div class="notice supermarket-shopping-notice is-dismissible">
        <div>
            <h3>
                <span><?php echo esc_html( '(Version: ' . $supermarket_shopping_theme_version . ')' ); ?></span><br>
                <?php esc_html_e( 'Thank you for choosing,', 'supermarket-shopping'); ?>
                <?php echo esc_html( $supermarket_shopping_theme_title ); ?> <?php esc_html_e( '!!!', 'supermarket-shopping'); ?>
            </h3>
            <p><?php esc_html_e( 'Welcome! You can now easily start building your website using our beautiful and user-friendly themes. No need to worry about setup — with our one-click demo importer, your site can look just like the demo in minutes. All the tools and information you need to get started are right here!', 'supermarket-shopping'); ?></p>
            <a class="button button-primary supermarket-shopping-buy-now" href="<?php echo esc_url( SUPERMARKET_SHOPPING_DEMO_IMPORT_URL ); ?>" target="_blank">
                <?php esc_html_e( 'One Click Demo Import', 'supermarket-shopping') ?>
            </a>
            <a class="button button-primary supermarket-shopping-bundle-button" target="_blank" href="<?php echo esc_url( SUPERMARKET_SHOPPING_THEME_BUNDLE_URL ); ?>">
                <?php echo esc_html__( 'Get All 60+ Themes @ $79', 'supermarket-shopping' ); ?>
            </a>
        </div>
        <div class="supermarket-shopping-image-wrap">
            <img src="<?php echo esc_url(get_stylesheet_directory_uri() . '/screenshot.png'); ?>">
        </div>
        <canvas id="supermarket-shopping-notice-confetti"></canvas>
    </div>
    <?php
}
add_action('admin_notices', 'supermarket_shopping_promo_notice');

add_action('wp_ajax_supermarket_shopping_dismiss_notice', 'supermarket_shopping_dismiss_notice');
function supermarket_shopping_dismiss_notice() {
    update_option('supermarket_shopping_notice_dismissed', true);
    wp_send_json_success();
}

add_action('after_switch_theme', 'supermarket_shopping_reset_notice_on_activation');
function supermarket_shopping_reset_notice_on_activation() {
    delete_option('supermarket_shopping_notice_dismissed');
}

function supermarket_shopping_enqueue_admin_assets() {
    wp_enqueue_script(
        'supermarket-shopping-confetti',
        get_template_directory_uri() . '/demo-import/assets/js/confetti/confetti.min.js',
        ['jquery'],
        null,
        true
    );

    wp_enqueue_script(
        'supermarket-shopping-notice-confetti-js',
        get_template_directory_uri() . '/demo-import/assets/js/plugin-update-notice.js',
        ['supermarket-shopping-confetti'],
        null,
        true
    );

    wp_enqueue_script(
        'supermarket-shopping-notice-dismiss',
        get_template_directory_uri() . '/demo-import/assets/js/notice-dismiss.js',
        ['jquery'],
        null,
        true
    );
}
add_action('admin_enqueue_scripts', 'supermarket_shopping_enqueue_admin_assets');